#ifndef BASE_SUM_MODULE_H
#define BASE_SUM_MODULE_H



#include<vector>
#include<iostream>


using namespace std;


class Base_Sum_Module {

          private :
                  
                  int  in1;
                  vector<int> In2;
                  
          public: 
                  
                  vector<int> Out;
                  vector<int> CNF;
                  
                  Base_Sum_Module(int, vector<int>);
                  ~Base_Sum_Module();
                  
                  void xor_CNF(int, int, int&);
                  int and_CNF(int, int, int&);
                  
                  void Generate_CNF( int & );    

};                       

//Constructor()
Base_Sum_Module::Base_Sum_Module(int x, vector<int> v):in1(x), In2(v){ 

}


//Destructor()
Base_Sum_Module::~Base_Sum_Module() {
                                  
  // Empty Destructor                                
}


void Base_Sum_Module::xor_CNF(int a, int b, int & free_index){
    
    int y=free_index;     // allocate first available index to y (y=a XOR b) 
    free_index++;
    
    //  y <-> XOR (var1, var2)    =     (a || b || y' ) &&  (a || b' || y ) &&
    //                                    (a' || b || y ) && (a' || b' || y' ) 
    
    // add all the cnfs to the vector "CNF"
    
    CNF.push_back(a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(-b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    Out.push_back(y);    // Put y in the vector of output variables                     

}


int Base_Sum_Module::and_CNF(int a, int b, int & free_index){


    int y=free_index;
    free_index++;
    
// y <-> a AND b   =     (a || b || y' ) &&  (a || b' || y' ) &&
//                           (a' || b || y' ) && (a' || b' || y )
    
    
  
    CNF.push_back(a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(a);
    CNF.push_back(-b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    
    
    return y;          
}




//function Generate_CNF() generates  cnf for each logical gate in the Base_Sum Module, and copies them into the "CNF" vector.
// Each Base_Sum_Module computes the summation of a vector In2=(y_1,y_2 , ..., y_m) and a bit in1=x_i. In other words, 
// (y_m', ..., y_2', y_1') = (y_m, ..., y_2, y_1) + x_i
// 


void Base_Sum_Module::Generate_CNF(int & free_index) {
    
    int prv_carry, curr_carry;
    
    xor_CNF(in1, In2[0], free_index);
    curr_carry= and_CNF(in1, In2[0], free_index);
    
    
    for (int i=1; i<In2.size(); i++){
        
        prv_carry=curr_carry;
        xor_CNF(In2[i], prv_carry, free_index);
        curr_carry= and_CNF(In2[i], prv_carry, free_index);
    }
    
    
}







    

#endif
