#ifndef COMPARISION_MODULE_H
#define COMPARISION_MODULE_H


#include<vector>
#include<iostream>
#include"Exception.h"

using namespace std;

class Comparision_Module {
      
      private:
              
              vector<int> In1;   
              vector<int> In2; 
              
              
      public:
             
             int g;
             int e;             
             vector<int> CNF;
               
             Comparision_Module( vector<int>, vector<int>, int & );
             ~Comparision_Module();
             
             int imply_CNF(int, int, int&);
             int and_CNF(int, int, int&);
             int or_CNF(int, int, int&);
             
             int  greater_CNF(int, int , int, int, int &);
             int  equality_CNF(int , int , int , int &);
             
             void Generate_CNF(int & ); 
             
             
};

//Constructor()
Comparision_Module::Comparision_Module(vector<int> v1, vector<int>v2, int & free_index):In1(v1), In2(v2){

      if (v1.size()!= v2.size() ){
         
           throw illegal_argument();
         
         }
                                                                              
}


//Destructor()
Comparision_Module::~Comparision_Module(){
                                          
         // Empty Destructor                                 
                                          
}
 
 
      
void Comparision_Module::Generate_CNF(int & free_index){
        
        int prv_e, nxt_e, prv_g, nxt_g;
        int m=In1.size();
        
        prv_e=imply_CNF(In1[m-1], In2[m-1], free_index);
        prv_g= and_CNF(-In1[m-1], In2[m-1], free_index);                          
        
        for(int i=m-2 ; i>=0 ; i-- ){
        
               nxt_e = equality_CNF(In1[i], In2[i], prv_e, free_index);
               nxt_g = greater_CNF(In1[i], In2[i], prv_e, prv_g, free_index); 
               
               prv_e=nxt_e;
               prv_g=nxt_g;
               
        }                                 
             
        g=prv_g;
        e=prv_e;
} 



int  Comparision_Module::greater_CNF(int a, int b, int prv_e, int prv_g, int & free_index){  
     
     int x= and_CNF(-a, b,free_index);
     int y= and_CNF(prv_e, x, free_index);
     int nxt_g = or_CNF( y, prv_g, free_index);
     
            
     return nxt_g;
}



int  Comparision_Module::equality_CNF(int a, int b, int prv_e, int & free_index){  
     
     int nxt_e = and_CNF(prv_e, imply_CNF(a,b,free_index),  free_index);
            
     return nxt_e;
}



int  Comparision_Module::imply_CNF(int a, int b, int & free_index){

     int y=free_index;
     free_index++;
    
// y <-> (a <-> b)   =     (a || b || y ) &&  (a || b' || y' ) &&
//                             (a' || b || y' ) && (a' || b' || y )
    
    
  
    CNF.push_back(a);
    CNF.push_back(b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    CNF.push_back(a);
    CNF.push_back(-b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    
    
    return y;           
          
} 



int Comparision_Module::and_CNF(int a, int b, int & free_index){


    int y=free_index;
    free_index++;
    
// y <-> a AND b   =     (a || b || y' ) &&  (a || b' || y' ) &&
//                          (a' || b || y' ) && (a' || b' || y )
    
    
  
    CNF.push_back(a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(a);
    CNF.push_back(-b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    
    
    return y;          
}


int Comparision_Module::or_CNF(int a, int b, int & free_index){

    int y=free_index;
    free_index++;
    
// y <-> a OR b   =     (a || b || y' ) &&  (a || b' || y ) &&
//                          (a' || b || y ) && (a' || b' || y )
    
    
  
    CNF.push_back(a);
    CNF.push_back(b);
    CNF.push_back(-y);
    CNF.push_back(0);
    
    CNF.push_back(a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    CNF.push_back(-a);
    CNF.push_back(-b);
    CNF.push_back(y);
    CNF.push_back(0);
    
    
    
    return y;         
         
}

      
#endif 
