#ifndef SUM_MODULE_H
#define SUM_MODULE_H


#include<vector>
#include <math.h>
#include<iostream>
#include "Base_Sum_Module.h"


class Sum_Module {
      
      private:
              
              vector<int> In1;   
              vector<int> In2;            
              
              
      public:
              
              vector<int> CNF;
              vector<int> Out;
              
              Sum_Module(vector<int>, int &);
              ~Sum_Module();
              
              void copy_to_CNF(vector<int> );
              void Initial_CNF();
              void Generate_CNF(int &); 
             
      
};


// Constructor
Sum_Module::Sum_Module(vector<int> v, int & free_index):In1(v){ 

      int m= int( floor( log(In1.size())/ log(2) ) )+1;


      for(int i=0; i< m ; i++){

          In2.push_back(free_index);
          free_index++;

      }


}


// Destructor 
Sum_Module::~Sum_Module(){
                          
}




void Sum_Module::Generate_CNF(int & free_index){
                        
   Initial_CNF();
   vector<int> nxt_In=In2;


   for(int i=0; i<In1.size(); i++){
        
        
        Base_Sum_Module* module = new Base_Sum_Module(In1[i], nxt_In);
        module->Generate_CNF(free_index);
        copy_to_CNF(module->CNF);
        nxt_In=module->Out;

        delete module;
                        
   }

   Out=nxt_In;  // copy the output variables of the last base_sum module into the output variables of the Sum module

}



void Sum_Module::Initial_CNF(){
     
     
     for (int i=0; i< In2.size(); i++){
             
          CNF.push_back(-In2[i]);
          CNF.push_back(0);
          
     }
     
}



void Sum_Module::copy_to_CNF(vector<int> v){
     
     for (int i=0; i< v.size(); i++){
         
         CNF.push_back(v[i]);
         
     }
     
}
     
#endif     










