#ifndef K_CHECK_H
#define K_CHECK_H


#include<vector>
#include<iostream>
#include"Exception.h"
#include"Sum_Module.h"
#include"Comparision_Module.h"



using namespace std;


class K_Check {
      
      private:
             
             vector<int> In;
             int k;
             int OBJ;    //0 means min, 1 means max
             
      
      public:
             
             vector<int> CNF;
             
             K_Check(vector<int> , int, int);
             ~K_Check();
             
             void copy_to_CNF(vector<int>);
             vector<int> binary(int, int, int& );
             void Generate_CNF(int & );
             
             
};

//Constructor()
K_Check::K_Check(vector<int> v , int n, int m):In(v), k(n), OBJ(m){       


}

//Destructor()
K_Check::~K_Check(){
    
    //Empty Destructor
}


void K_Check::Generate_CNF(int & free_index){

     Sum_Module * Add_module = new Sum_Module(In, free_index); 
     Add_module->Generate_CNF(free_index);
      
     vector<int> Add_out=Add_module->Out;
     copy_to_CNF(Add_module->CNF);
     
     
     vector<int> binary_rep_k =binary(k, Add_out.size(), free_index);
     
     Comparision_Module * Comp_Module= new Comparision_Module(Add_out, binary_rep_k, free_index); 
     Comp_Module->Generate_CNF(free_index);
     copy_to_CNF(Comp_Module->CNF);
     
     if (OBJ==0 ){
                
          CNF.push_back(Comp_Module->g); 
          CNF.push_back(Comp_Module->e);
          CNF.push_back(0);
          
     }else if (OBJ==1){
           
           CNF.push_back(-Comp_Module->g); 
           CNF.push_back(Comp_Module->e);
           CNF.push_back(0);
     }
     
     
     delete  Add_module;
     delete  Comp_Module;
     
}

// binary() returns the binary representation of k in a vector of size m 
vector<int> K_Check::binary(int n, int m, int & free_index){
    
    if ( (1 << m)-1 < n ){
         
         throw underflow();
    }
    

    vector<int> v;
    int i=0;
    
    while (i < m ){
          
          int new_var= free_index;
          free_index++;
          v.push_back(new_var);
          
          if (( n & (1 << i) )== 0 ){
                   
                   CNF.push_back(-new_var);
                   CNF.push_back(0);
          } else {
                   
                   CNF.push_back(new_var);
                   CNF.push_back(0);
          }
          
          i++;
    }
    
    return v;
    
}    


void K_Check::copy_to_CNF(vector<int> v){
     
     for (int i=0; i< v.size(); i++){
         
         CNF.push_back(v[i]);
         
     }
     
}

#endif







